<!--
Component that shows the overview of a competition for the
user to click on when browsing competitions.
-->
<template>
    <b-card :id="competition._id">
      <div slot="header" @click="expanded = !expanded">
        <h6 class="mb-0" style="font-weight: bold; float: left">
          <span style="float: left" id="competition_title">{{ this.competition.getTitle() }}</span>
          <tag-list style="display: inline" :tags="this.competition.getTags()" :inline="true"/>
        </h6>
        <span style="float: right;">
          <up-arrow v-show="expanded"/>
          <down-arrow v-show="!expanded"/>
        </span>
      </div>

        <b-collapse :id="'collapse'" v-model="expanded">
          <div style="min-height: 150px">
            <img :src="this.competition.getImageUrl()" style="max-width: 250px; float: left; margin-right: 10px"/>
            <p style="float: left; max-width: 70%">{{ this.competition.getDescription() }}</p>
            <p style="position: absolute; bottom: 25px; right: 5px">
              Closes {{ this.competition.getDeadline().toLocaleDateString() }}
              at     {{ this.competition.getDeadline().toLocaleTimeString() }}
            </p>

            <b-button variant="primary" 
                      size="sm" 
                      :to="'/ContestView/' + this.competition._id"
                      style="position: absolute; bottom: 5px; right: 5px">
              View Competition Page
            </b-button>
          </div>
        </b-collapse>
    </b-card>
</template>
<script>
import Competition from '@/models/Competition'
import TagList from '@/components/TagList'
import DownArrow from 'vue-material-design-icons/chevron-down.vue'
import UpArrow from 'vue-material-design-icons/chevron-up.vue'

export default {
    name: 'CompetitionSummaryPanel',
    props: {
        competition: Competition
    },
    components: {
        TagList: TagList,
        UpArrow: UpArrow,
        DownArrow: DownArrow
    },
    
    data: function() {
        return {
            expanded: false
        }
    }
}
</script>
